package lib.dw;

public class DwOpEncodings
  implements Comparable
{
  private final String enumString;
  private final int enumValue;
  private final String enumPrint;
  private final String enumName;
  private DwOpEncodings (int value, String string, String print, String name)
  {
    enumString = string;
    enumValue = value;
    enumPrint = print;
    enumName = name;
  }
  /** Return the qualified name of the enum.  */
  public String toString ()
  {
    return enumString;
  }
  /** Return a printable version of the enum.  */
  public String toPrint ()
  {
    return enumPrint;
  }
  /** Return the name of just the enum.  */
  public String toName ()
  {
    return enumName;
  }
  public boolean equals (Object o)
  {
    if (o instanceof DwOpEncodings)
      return ((DwOpEncodings) o).enumValue == this.enumValue;
    else
      return false;
  }
  public int hashCode ()
  {
    return enumValue;
  }
  public int compareTo (Object o)
  {
    DwOpEncodings rhs = (DwOpEncodings) o; // Can throw - ok.
    return rhs.enumValue - this.enumValue;
  }
  static public final int DW_OP_addr_ = 0x03;
  static public final DwOpEncodings DW_OP_addr = new DwOpEncodings (0x03, "DwOpEncodings_DW_OP_addr", "DW OP addr", "DW_OP_addr");
  static public final int DW_OP_plus_uconst_ = 0x23;
  static public final DwOpEncodings DW_OP_plus_uconst = new DwOpEncodings (0x23, "DwOpEncodings_DW_OP_plus_uconst", "DW OP plus uconst", "DW_OP_plus_uconst");
  static public final int DW_OP_reg0_ = 0x50;
  static public final DwOpEncodings DW_OP_reg0 = new DwOpEncodings (0x50, "DwOpEncodings_DW_OP_reg0", "DW OP reg0", "DW_OP_reg0");
  static public final int DW_OP_reg1_ = 0x51;
  static public final DwOpEncodings DW_OP_reg1 = new DwOpEncodings (0x51, "DwOpEncodings_DW_OP_reg1", "DW OP reg1", "DW_OP_reg1");
  static public final int DW_OP_reg2_ = 0x52;
  static public final DwOpEncodings DW_OP_reg2 = new DwOpEncodings (0x52, "DwOpEncodings_DW_OP_reg2", "DW OP reg2", "DW_OP_reg2");
  static public final int DW_OP_reg3_ = 0x53;
  static public final DwOpEncodings DW_OP_reg3 = new DwOpEncodings (0x53, "DwOpEncodings_DW_OP_reg3", "DW OP reg3", "DW_OP_reg3");
  static public final int DW_OP_reg4_ = 0x54;
  static public final DwOpEncodings DW_OP_reg4 = new DwOpEncodings (0x54, "DwOpEncodings_DW_OP_reg4", "DW OP reg4", "DW_OP_reg4");
  static public final int DW_OP_reg5_ = 0x55;
  static public final DwOpEncodings DW_OP_reg5 = new DwOpEncodings (0x55, "DwOpEncodings_DW_OP_reg5", "DW OP reg5", "DW_OP_reg5");
  static public final int DW_OP_reg6_ = 0x56;
  static public final DwOpEncodings DW_OP_reg6 = new DwOpEncodings (0x56, "DwOpEncodings_DW_OP_reg6", "DW OP reg6", "DW_OP_reg6");
  static public final int DW_OP_reg7_ = 0x57;
  static public final DwOpEncodings DW_OP_reg7 = new DwOpEncodings (0x57, "DwOpEncodings_DW_OP_reg7", "DW OP reg7", "DW_OP_reg7");
  static public final int DW_OP_reg8_ = 0x58;
  static public final DwOpEncodings DW_OP_reg8 = new DwOpEncodings (0x58, "DwOpEncodings_DW_OP_reg8", "DW OP reg8", "DW_OP_reg8");
  static public final int DW_OP_reg9_ = 0x59;
  static public final DwOpEncodings DW_OP_reg9 = new DwOpEncodings (0x59, "DwOpEncodings_DW_OP_reg9", "DW OP reg9", "DW_OP_reg9");
  static public final int DW_OP_reg10_ = 0x5a;
  static public final DwOpEncodings DW_OP_reg10 = new DwOpEncodings (0x5a, "DwOpEncodings_DW_OP_reg10", "DW OP reg10", "DW_OP_reg10");
  static public final int DW_OP_reg11_ = 0x5b;
  static public final DwOpEncodings DW_OP_reg11 = new DwOpEncodings (0x5b, "DwOpEncodings_DW_OP_reg11", "DW OP reg11", "DW_OP_reg11");
  static public final int DW_OP_reg12_ = 0x5c;
  static public final DwOpEncodings DW_OP_reg12 = new DwOpEncodings (0x5c, "DwOpEncodings_DW_OP_reg12", "DW OP reg12", "DW_OP_reg12");
  static public final int DW_OP_reg13_ = 0x5d;
  static public final DwOpEncodings DW_OP_reg13 = new DwOpEncodings (0x5d, "DwOpEncodings_DW_OP_reg13", "DW OP reg13", "DW_OP_reg13");
  static public final int DW_OP_reg14_ = 0x5e;
  static public final DwOpEncodings DW_OP_reg14 = new DwOpEncodings (0x5e, "DwOpEncodings_DW_OP_reg14", "DW OP reg14", "DW_OP_reg14");
  static public final int DW_OP_reg15_ = 0x5f;
  static public final DwOpEncodings DW_OP_reg15 = new DwOpEncodings (0x5f, "DwOpEncodings_DW_OP_reg15", "DW OP reg15", "DW_OP_reg15");
  static public final int DW_OP_breg0_ = 0x70;
  static public final DwOpEncodings DW_OP_breg0 = new DwOpEncodings (0x70, "DwOpEncodings_DW_OP_breg0", "DW OP breg0", "DW_OP_breg0");
  static public final int DW_OP_breg1_ = 0x71;
  static public final DwOpEncodings DW_OP_breg1 = new DwOpEncodings (0x71, "DwOpEncodings_DW_OP_breg1", "DW OP breg1", "DW_OP_breg1");
  static public final int DW_OP_breg2_ = 0x72;
  static public final DwOpEncodings DW_OP_breg2 = new DwOpEncodings (0x72, "DwOpEncodings_DW_OP_breg2", "DW OP breg2", "DW_OP_breg2");
  static public final int DW_OP_breg3_ = 0x73;
  static public final DwOpEncodings DW_OP_breg3 = new DwOpEncodings (0x73, "DwOpEncodings_DW_OP_breg3", "DW OP breg3", "DW_OP_breg3");
  static public final int DW_OP_breg4_ = 0x74;
  static public final DwOpEncodings DW_OP_breg4 = new DwOpEncodings (0x74, "DwOpEncodings_DW_OP_breg4", "DW OP breg4", "DW_OP_breg4");
  static public final int DW_OP_breg5_ = 0x75;
  static public final DwOpEncodings DW_OP_breg5 = new DwOpEncodings (0x75, "DwOpEncodings_DW_OP_breg5", "DW OP breg5", "DW_OP_breg5");
  static public final int DW_OP_breg6_ = 0x76;
  static public final DwOpEncodings DW_OP_breg6 = new DwOpEncodings (0x76, "DwOpEncodings_DW_OP_breg6", "DW OP breg6", "DW_OP_breg6");
  static public final int DW_OP_breg7_ = 0x77;
  static public final DwOpEncodings DW_OP_breg7 = new DwOpEncodings (0x77, "DwOpEncodings_DW_OP_breg7", "DW OP breg7", "DW_OP_breg7");
  static public final int DW_OP_fbreg_ = 0x91;
  static public final DwOpEncodings DW_OP_fbreg = new DwOpEncodings (0x91, "DwOpEncodings_DW_OP_fbreg", "DW OP fbreg", "DW_OP_fbreg");

  /** Create a HashMap containing all the DwOpEncodings elements.  */
  private static java.util.Map getMap ()
  {
    java.util.Map map;
    map = new java.util.HashMap ();
    map.put (DW_OP_addr.enumString, DW_OP_addr);
    map.put (DW_OP_plus_uconst.enumString, DW_OP_plus_uconst);
    map.put (DW_OP_reg0.enumString, DW_OP_reg0);
    map.put (DW_OP_reg1.enumString, DW_OP_reg1);
    map.put (DW_OP_reg2.enumString, DW_OP_reg2);
    map.put (DW_OP_reg3.enumString, DW_OP_reg3);
    map.put (DW_OP_reg4.enumString, DW_OP_reg4);
    map.put (DW_OP_reg5.enumString, DW_OP_reg5);
    map.put (DW_OP_reg6.enumString, DW_OP_reg6);
    map.put (DW_OP_reg7.enumString, DW_OP_reg7);
    map.put (DW_OP_reg8.enumString, DW_OP_reg8);
    map.put (DW_OP_reg9.enumString, DW_OP_reg9);
    map.put (DW_OP_reg10.enumString, DW_OP_reg10);
    map.put (DW_OP_reg11.enumString, DW_OP_reg11);
    map.put (DW_OP_reg12.enumString, DW_OP_reg12);
    map.put (DW_OP_reg13.enumString, DW_OP_reg13);
    map.put (DW_OP_reg14.enumString, DW_OP_reg14);
    map.put (DW_OP_reg15.enumString, DW_OP_reg15);
    map.put (DW_OP_breg0.enumString, DW_OP_breg0);
    map.put (DW_OP_breg1.enumString, DW_OP_breg1);
    map.put (DW_OP_breg2.enumString, DW_OP_breg2);
    map.put (DW_OP_breg3.enumString, DW_OP_breg3);
    map.put (DW_OP_breg4.enumString, DW_OP_breg4);
    map.put (DW_OP_breg5.enumString, DW_OP_breg5);
    map.put (DW_OP_breg6.enumString, DW_OP_breg6);
    map.put (DW_OP_breg7.enumString, DW_OP_breg7);
    map.put (DW_OP_fbreg.enumString, DW_OP_fbreg);
    return map;
  }
  private static java.util.Map enumMap = getMap ();

  /** Return the DwOpEncodings object that matches the string.  */
  public static DwOpEncodings valueOf (String string)
  {
    return (DwOpEncodings)enumMap.get (string);
  }

  /** Return the DwOpEncodings object that matches the integer.  */
  public static DwOpEncodings valueOf (long i)
  {
    switch ((int)i) {
    case DW_OP_addr_: return DW_OP_addr;
    case DW_OP_plus_uconst_: return DW_OP_plus_uconst;
    case DW_OP_reg0_: return DW_OP_reg0;
    case DW_OP_reg1_: return DW_OP_reg1;
    case DW_OP_reg2_: return DW_OP_reg2;
    case DW_OP_reg3_: return DW_OP_reg3;
    case DW_OP_reg4_: return DW_OP_reg4;
    case DW_OP_reg5_: return DW_OP_reg5;
    case DW_OP_reg6_: return DW_OP_reg6;
    case DW_OP_reg7_: return DW_OP_reg7;
    case DW_OP_reg8_: return DW_OP_reg8;
    case DW_OP_reg9_: return DW_OP_reg9;
    case DW_OP_reg10_: return DW_OP_reg10;
    case DW_OP_reg11_: return DW_OP_reg11;
    case DW_OP_reg12_: return DW_OP_reg12;
    case DW_OP_reg13_: return DW_OP_reg13;
    case DW_OP_reg14_: return DW_OP_reg14;
    case DW_OP_reg15_: return DW_OP_reg15;
    case DW_OP_breg0_: return DW_OP_breg0;
    case DW_OP_breg1_: return DW_OP_breg1;
    case DW_OP_breg2_: return DW_OP_breg2;
    case DW_OP_breg3_: return DW_OP_breg3;
    case DW_OP_breg4_: return DW_OP_breg4;
    case DW_OP_breg5_: return DW_OP_breg5;
    case DW_OP_breg6_: return DW_OP_breg6;
    case DW_OP_breg7_: return DW_OP_breg7;
    case DW_OP_fbreg_: return DW_OP_fbreg;
    default: return null;
    }
  }

  /** Return an array of all the DwOpEncodings elements.  */
  public static DwOpEncodings[] values ()
  {
    return (DwOpEncodings[]) enumMap.values ().toArray (new DwOpEncodings[0]);
  }

  /**
   * Returns the full underscore delimited name of the
   * field corresponding to the value I.
   */
  static public String toString (long i)
  {
    DwOpEncodings c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toString ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I.
   */
  static public String toPrintString (long i)
  {
    DwOpEncodings c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toPrint ();
  }

  /**
   * Returns the printable (or user readable) name for the
   * field corresponding to the value I, or DEF is there
   * is no such field.
   */
  static public String toPrintString (long i, String def)
  {
    DwOpEncodings c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toPrint ();
  }

  /**
   * Returns just the name part of the num corresponding to I.
   */
  static public String toName (long i)
  {
    DwOpEncodings c = valueOf (i);
    if (c == null)
      return "_0x" + Long.toHexString (i);
    else
      return c.toName ();
  }

  /**
   * Returns just the name part of the num corresponding to I,
   * or DEF is there is no such field.
   */
  static public String toName (long i, String def)
  {
    DwOpEncodings c = valueOf (i);
    if (c == null)
      return def;
    else
      return c.toName ();
  }
}
